﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Dynamic;

namespace SfGrid.Sample
{
    class ViewModel:INotifyPropertyChanged
    {
        #region Private Members
        private List<OrderInfo> _orderDetails;
        private List<DateTime> OrderedDates;
        private List<DateTime> ShippedDates;
        private List<dynamic>dynamincCollection;
        


        Random r = new Random();
        Dictionary<string, string[]> ShipCity = new Dictionary<string, string[]>();

        #endregion
        public ViewModel()
        {
            _orderDetails = GetOrders(100);

        }

        public List<string> Customers
        {
            get
            {
                return this.CustomerID.ToList();
            }
        }
        public List<string> ShipCountries
        {
            get
            {
                return this.ShipCountry.ToList();
            }
            set { ShipCountry = value.ToArray(); }
        }
        public List<OrderInfo> OrderDetails
        {
            get
            {
                return _orderDetails;
            }
        }
      
        string[] productName = new string[]
        {
            "Alice Mutton",	
            "NuNuCa Nuß-Nougat-Creme",	
            "Boston Crab Meat",	
            "Raclette Courdavault",	
            "Wimmers gute Semmelknödel",
            "Gorgonzola Telino",	
            "Chartreuse verte",	
            "Fløtemysost",	
            "Carnarvon Tigers",	
            "Thüringer Rostbratwurst",	
            "Vegie-spread",	
            "Tarte au sucre",	
            "Konbu",	
            "Valkoinen suklaa",	
            "Queso Manchego La Pastora",	
            "Perth Pasties",	
            "Vegie-spread",	
            "Tofu",	
            "Sir Rodney's Scone 7",	
            "Manjimup Dried Apples"
        };
        string[] CustomerID = new string[]
        {
            "ALFKI",
            "FRANS",
            "MEREP",
            "FOLKO",
            "SIMOB",
            "WARTH",
            "VAFFE",
            "FURIB",
            "SEVES",
            "LINOD",
            "RISCU",
            "PICCO",
            "BLONP",
            "WELLI",
            "FOLIG"
        };

       

        /// <summary>
        /// Collection of ship country
        /// </summary>
        string[] ShipCountry = new string[]
        {
            "Argentina",
            "Austria",
            "Belgium",
            "Brazil",            
            "Canada",
            "Denmark",
            "Finland",
            "France",
            "Germany",
            "Ireland",
            "Italy",
            "Mexico",
            "Norway",
            "Poland",
            "Portugal",
            "Spain",
            "Sweden",
            "Switzerland",
            "UK",
            "USA",
            "Venezuela"
        };

        double[] unitPrice = new double[] { 28.5, 36.2, 28.3, 86, 52, 41, 9, 91, 32.8, 4.5, 63.7, 34.2, 15.9, 21.9, 8, 10.3, 42.5, 7.2, 34.9, 9.9, 0, 59.2, 12.6, 19.8, 42.7 };

        /// <summary>
        /// Sets the ship city.
        /// </summary>
        private void SetShipCity()
        {
            string[] argentina = new string[] { "Buenos Aires" };

            string[] austria = new string[] { "Graz", "Salzburg" };

            string[] belgium = new string[] { "Bruxelles", "Charleroi" };

            string[] brazil = new string[] { "Campinas", "Resende", "Rio de Janeiro", "São Paulo" };

            string[] canada = new string[] { "Montréal", "Tsawassen", "Vancouver" };

            string[] denmark = new string[] { "Århus", "København" };

            string[] finland = new string[] { "Helsinki", "Oulu" };

            string[] france = new string[] { "Lille", "Lyon", "Marseille", "Nantes", "Paris", "Reims", "Strasbourg", "Toulouse", "Versailles" };

            string[] germany = new string[] { "Aachen", "Berlin", "Brandenburg", "Cunewalde", "Frankfurt a.M.", "Köln", "Leipzig", "Mannheim", "München", "Münster", "Stuttgart" };

            string[] ireland = new string[] { "Cork" };

            string[] italy = new string[] { "Bergamo", "Reggio Emilia", "Torino" };

            string[] mexico = new string[] { "México D.F." };

            string[] norway = new string[] { "Stavern" };

            string[] poland = new string[] { "Warszawa" };

            string[] portugal = new string[] { "Lisboa" };

            string[] spain = new string[] { "Barcelona", "Madrid", "Sevilla" };

            string[] sweden = new string[] { "Bräcke", "Luleå" };

            string[] switzerland = new string[] { "Bern", "Genève" };

            string[] uk = new string[] { "Colchester", "Hedge End", "London" };

            string[] usa = new string[] { "Albuquerque", "Anchorage", "Boise", "Butte", "Elgin", "Eugene", "Kirkland", "Lander", "Portland", "San Francisco", "Seattle", "Walla Walla" };

            string[] venezuela = new string[] { "Barquisimeto", "Caracas", "I. de Margarita", "San Cristóbal" };

            ShipCity.Add("Argentina", argentina);
            ShipCity.Add("Austria", austria);
            ShipCity.Add("Belgium", belgium);
            ShipCity.Add("Brazil", brazil);
            ShipCity.Add("Canada", canada);
            ShipCity.Add("Denmark", denmark);
            ShipCity.Add("Finland", finland);
            ShipCity.Add("France", france);
            ShipCity.Add("Germany", germany);
            ShipCity.Add("Ireland", ireland);
            ShipCity.Add("Italy", italy);
            ShipCity.Add("Mexico", mexico);
            ShipCity.Add("Norway", norway);
            ShipCity.Add("Poland", poland);
            ShipCity.Add("Portugal", portugal);
            ShipCity.Add("Spain", spain);
            ShipCity.Add("Sweden", sweden);
            ShipCity.Add("Switzerland", switzerland);
            ShipCity.Add("UK", uk);
            ShipCity.Add("USA", usa);
            ShipCity.Add("Venezuela", venezuela);

        }

        /// <summary>
        /// Collection of Customer ID
        /// </summary>
        

        public List<OrderInfo> GetOrders(int count)
        {
            List<OrderInfo> order = new List<OrderInfo>();
            SetShipCity();
            this.OrderedDates = this.GetDateBetween(2008, 2011, count);
            this.ShippedDates = this.GetDateBetween(2008, 2011, count);
            for (int i = 1; i < count; i++)
            {
                order.Add(GetOrder(i));
            }
            return order;
        }

        /// <summary>
        /// Gets the date between.
        /// </summary>
        /// <param name="startYear">The start year.</param>
        /// <param name="EndYear">The end year.</param>
        /// <param name="Count">The count.</param>
        /// <returns></returns>
        private List<DateTime> GetDateBetween(int startYear, int EndYear, int Count)
        {
            List<DateTime> date = new List<DateTime>();
            Random d = new Random(1);
            Random m = new Random(2);
            Random y = new Random(startYear);
            for (int i = 0; i < Count; i++)
            {
                int year = y.Next(startYear, EndYear);
                int month = m.Next(3, 13);
                int day = d.Next(1, 31);

                date.Add(new DateTime(year, month, day));
            }
            return date;
        }

        /// <summary>
        /// Gets the order.
        /// </summary>
        /// <param name="i">The i.</param>
        /// <returns></returns>
        private OrderInfo GetOrder(int i)
        {
            var shipcountry = ShipCountry[r.Next(5)];
            var shipcitycoll = ShipCity[shipcountry];
            DateTime d = this.OrderedDates[i];
            return new OrderInfo()
            {
                OrderID = i,
                CustomerID = CustomerID[r.Next(15)],
                ProductName = productName[r.Next(20)],
                UnitPrice = unitPrice[r.Next(24)],
                Discount = Math.Round(r.Next(10) + r.NextDouble(), 2),
                Quantity = r.Next(50),
                Freight = Math.Round(r.Next(100) + r.NextDouble(), 2),
                ShipCountry = shipcountry,
                ShipCity = shipcitycoll[r.Next(shipcitycoll.Length - 1)],
                OrderDate = this.OrderedDates[i],
                ShippedDate = this.ShippedDates[i],
                IsClosed = r.Next() % 2 == 0 ? true : false,
                ContactNumber = r.Next(321341, 321349).ToString()
            };
        }
    
public event PropertyChangedEventHandler PropertyChanged;
public void RaisePropertyChanged(string propName)
{
    if (this.PropertyChanged != null)
        this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
}
}
     
        
}
